      PARAMETER (LX=144,MX=73,NNX=42)
      REAL BC(LX,MX,0:NNX,0:NNX),BS(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     DM1(LX,MX),DM2(LX,MX)
      CHARACTER OUTFL*80

      CALL BASES  (LX,MX,NNX,BC,BS)
      CALL WEIGHT (LX,MX,W)
      WRITE(6,*) 'Orthogonizing bases...'
      CALL NORML  (LX,MX,NNX,W,BC,BS)
      CALL ORTHO  (LX,MX,NNX,W,BC,BS,DM1,DM2)
      CALL NORML  (LX,MX,NNX,W,BC,BS)

      OUTFL='bases73_cos.dat'
      CALL WRDAT  (LX,MX,NNX+1,NNX+1,OUTFL,BC)
      OUTFL='bases73_sin.dat'
      CALL WRDAT  (LX,MX,NNX+1,NNX+1,OUTFL,BS)
      OUTFL='weight73.dat'
      CALL WRDAT  (LX,MX,1,1,OUTFL,W)
      STOP
      END

C ========================================
C   Subroutines
C ========================================

      SUBROUTINE BASES (LX,MX,NNX,BC,BS)
      REAL BC(LX,MX,0:NNX,0:NNX),BS(LX,MX,0:NNX,0:NNX)
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
      DO 21 M=1,MX
      DO 22 L=1,LX
      CALL SCORD (LX,MX,L,M,X,Y)
        BC(L,M,MM,NN) = HARMO(NN,MM,'C',X,Y)
      IF (MM.NE.0) BS(L,M,MM,NN) = HARMO(NN,MM,'S',X,Y)
   22 CONTINUE
   21 CONTINUE
      WRITE(6,'(2I4)') NN,MM
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE WEIGHT (LX,MX,W)
      REAL W(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
      CALL SCORD (LX,MX,L,M,X,Y)
        W(L,M) = COS(Y)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SCORD (LX,MX,L,M,X,Y)
      PI = 0.31415926535E1
        X = 0.2E1*PI*REAL(L-1)/REAL(LX)
        Y = 0.5E0*PI-PI*REAL(M-1)/REAL(MX-1)
      RETURN
      END

      SUBROUTINE ORTHO (LX,MX,NNX,W,BC,BS,G,G0)
      REAL BC(LX,MX,0:NNX,0:NNX),BS(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),G0(LX,MX)
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
C cos-type
      CALL ORTHO1 (LX,MX,NNX,MM,NN,BC,G)
      DO 21 NNN=1,NN
      MMMX = NNN
      IF (NNN.EQ.NN) MMMX = MM
      DO 22 MMM=0,MMMX
      IF ((NNN.EQ.NN).AND.(MMM.EQ.MM)) GO TO 29
      CALL ORTHO1 (LX,MX,NNX,MMM,NNN,BC,G0)
      CALL ORTHO2 (LX,MX,W,G0,G)
      IF (MMM.NE.0) THEN
      CALL ORTHO1 (LX,MX,NNX,MMM,NNN,BS,G0)
      CALL ORTHO2 (LX,MX,W,G0,G)
      ENDIF
   29 CONTINUE
   22 CONTINUE
   21 CONTINUE
      CALL ORTHO3 (LX,MX,NNX,MM,NN,G,BC)
C sin-type
      CALL ORTHO1 (LX,MX,NNX,MM,NN,BS,G)
      DO 31 NNN=1,NNX
      MMMX = NNN
      IF (NNN.EQ.NN) MMMX = MM
      DO 32 MMM=0,MMMX
      CALL ORTHO1 (LX,MX,NNX,MMM,NNN,BC,G0)
      CALL ORTHO2 (LX,MX,W,G0,G)
      IF ((NNN.EQ.NN).AND.(MMM.EQ.MM)) GO TO 39
      IF (MMM.NE.0) THEN
      CALL ORTHO1 (LX,MX,NNX,MMM,NNN,BS,G0)
      CALL ORTHO2 (LX,MX,W,G0,G)
      ENDIF
   39 CONTINUE
   32 CONTINUE
   31 CONTINUE
      CALL ORTHO3 (LX,MX,NNX,MM,NN,G,BS)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ORTHO1 (LX,MX,NNX,MM,NN,B,G)
      REAL B(LX,MX,0:NNX,0:NNX),G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        G(L,M) = B(L,M,MM,NN)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ORTHO2 (LX,MX,W,G0,G)
      REAL W(LX,MX),G0(LX,MX),G(LX,MX)
        SUM1 = 0.0E0
        SUM0 = 0.0E0 
      DO 11 M=1,MX
      DO 12 L=1,LX
        SUM1 = SUM1 + W(L,M) * G0(L,M) * G(L,M)
        SUM0 = SUM0 + W(L,M) * G0(L,M)**2
   12 CONTINUE
   11 CONTINUE
        C = SUM1 / SUM0
      DO 21 M=1,MX
      DO 22 L=1,LX
        G(L,M) = G(L,M) - C * G0(L,M)
   22 CONTINUE
   21 CONTINUE
      RETURN
      END

      SUBROUTINE ORTHO3 (LX,MX,NNX,MM,NN,G,B)
      REAL G(LX,MX),B(LX,MX,0:NNX,0:NNX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        B(L,M,MM,NN) = G(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE NORML (LX,MX,NNX,W,BC,BS)
      REAL BC(LX,MX,0:NNX,0:NNX),BS(LX,MX,0:NNX,0:NNX),W(LX,MX)
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        SUM1 = 0.0E0
        SUM0 = 0.0E0
      DO 21 M=1,MX
      DO 22 L=1,LX
        SUM1 = SUM1 + W(L,M) * BC(L,M,MM,NN)**2
        SUM0 = SUM0 + W(L,M)
   22 CONTINUE
   21 CONTINUE
      C = SQRT(SUM0/SUM1)
      DO 31 M=1,MX
      DO 32 L=1,LX
        BC(L,M,MM,NN) = C * BC(L,M,MM,NN)
   32 CONTINUE
   31 CONTINUE
      IF (MM.NE.0) THEN
        SUM1 = 0.0E0
        SUM0 = 0.0E0
      DO 41 M=1,MX
      DO 42 L=1,LX
        SUM1 = SUM1 + W(L,M) * BS(L,M,MM,NN)**2
        SUM0 = SUM0 + W(L,M)
   42 CONTINUE
   41 CONTINUE
      C = SQRT(SUM0/SUM1)
      DO 51 M=1,MX
      DO 52 L=1,LX
        BS(L,M,MM,NN) = C * BS(L,M,MM,NN)
   52 CONTINUE
   51 CONTINUE
      ENDIF
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE ZERO (L1,L2,M1,M2,G)
      REAL G(L1:L2,M1:M2)
      DO 11 M=M1,M2
      DO 12 L=L1,L2
        G(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE WRDAT (IX,JX,KX,LX,OUTFL,G)
      REAL G(IX,JX,KX,LX)
      CHARACTER OUTFL*80
      OPEN(10,FILE=OUTFL,
     +     STATUS='UNKNOWN',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(IX*JX*KX*LX))
      WRITE(10,REC=1) G
      CLOSE(10)
      RETURN
      END

C ========================================
C   Subroutines to obtain spherical harmonic functions
C ========================================

C   N,M : Mode No.
C   C : 'S' = sin-type in longitude, 'C' = cos-type in longitude.
C   X : Longitude in radian
C   Y : Latitude in radian

      REAL FUNCTION HARMO (N,M,C,X,Y)
      CHARACTER C*1
      HARMO = 0.0E0
      Z = SIN(Y)
      IF (C.EQ.'S') HARMO = RLEGEN (N,M,Z) * SIN (REAL(M)*X)
      IF (C.EQ.'C') HARMO = RLEGEN (N,M,Z) * COS (REAL(M)*X)
      RETURN
      END

C      REAL FUNCTION RLEGEN (N,M,Z)
C      REAL C(0:100)
C      NX = 100
C      RLEGEN = 0.0E0
C      IF (ABS(Z).GT.1.0E0) RETURN
C      CALL LEGEN1 (NX,N,M,C)
C      RLEGEN = POLY (NX,C,Z)
C      IF (M.EQ.0) RETURN
C      IF (ABS(Z).EQ.1.0E0) RLEGEN = 0.0E0
C      IF (ABS(Z).EQ.1.0E0) RETURN
C      C1 = (SQRT(1.0E0 - Z**2))**M
C      RLEGEN = C1 * RLEGEN
C      RETURN
C      END

      REAL FUNCTION RLEGEN (N,M,Z)
      REAL*8 C(0:100),RLEG8,Z8,C1,POLY
      NX = 100
      RLEG8 = 0.0D0
      Z8 = DBLE(Z)
      IF (DABS(Z8).GT.1.0D0) RLEGEN = REAL(RLEG8)
      IF (DABS(Z8).GT.1.0D0) RETURN
      CALL LEGEN1 (NX,N,M,C)
      RLEG8 = POLY (NX,C,Z8)
      IF (M.EQ.0) RLEGEN = REAL(RLEG8)
      IF (M.EQ.0) RETURN
      IF (DABS(Z8).EQ.1.0D0) RLEG8 = 0.0D0
      IF (DABS(Z8).EQ.1.0D0) RLEGEN = REAL(RLEG8)
      IF (DABS(Z8).EQ.1.0D0) RETURN
      C1 = (DSQRT(1.0D0 - Z8**2))**M
      RLEG8 = C1 * RLEG8
      RLEGEN = REAL(RLEG8)
      RETURN
      END

C      SUBROUTINE LEGEN0 (NX,N,C)
C      REAL C(0:NX)
C      DO 11 M=0,NX
C        C(M) = 0.0E0
C   11 CONTINUE
C        C(N) = 1.0E0
C        M = N
C   21 CONTINUE
C        M = M - 2
C        IF (M.LT.0) GO TO 29
C        C(M) = - REAL((M+1)*(M+2))
C     +         / (REAL(N*(N+1)) - REAL(M*(M+1)))
C     +         * C(M+2)
C      GO TO 21
C   29 CONTINUE
C      RETURN
C      END

      SUBROUTINE LEGEN0 (NX,N,C)
      REAL*8 C(0:NX)
      DO 11 M=0,NX
        C(M) = 0.0D0
   11 CONTINUE
        C(N) = 1.0D0
        M = N
   21 CONTINUE
        M = M - 2
        IF (M.LT.0) GO TO 29
        C(M) = - DBLE((M+1)*(M+2))
     +         / (DBLE(N*(N+1)) - DBLE(M*(M+1)))
     +         * C(M+2)
      GO TO 21
   29 CONTINUE
      RETURN
      END

      SUBROUTINE LEGEN1 (NX,N,M,C)
C      REAL C(0:NX)
      REAL*8 C(0:NX)
        CALL LEGEN0 (NX,N,C)
      DO 11 MM=1,M
        CALL DIFF (NX,N,C)
        CALL NORM (NX,C)
   11 CONTINUE
      RETURN
      END

C      SUBROUTINE DIFF (NX,N,C)
C      REAL C(0:NX)
C      DO 11 M=0,NX-1
C        C(M) = REAL(M+1) * C(M+1)
C   11 CONTINUE
C        C(NX) = 0.0E0
C      RETURN
C      END

      SUBROUTINE DIFF (NX,N,C)
      REAL*8 C(0:NX)
      DO 11 M=0,NX-1
        C(M) = DBLE(M+1) * C(M+1)
   11 CONTINUE
        C(NX) = 0.0D0
      RETURN
      END

C      SUBROUTINE NORM (NX,C)
C      REAL C(0:NX)
C      DO 11 NN=NX,0,-1
C      N = NN
C      IF (C(N).NE.0.0E0) GO TO 19
C   11 CONTINUE
C      RETURN
C   19 CONTINUE
C      DO 21 NN=0,N-1
C        C(NN) = C(NN) / C(N)
C   21 CONTINUE
C        C(N) = 1.0E0
C      RETURN
C      END

      SUBROUTINE NORM (NX,C)
      REAL*8 C(0:NX)
      DO 11 NN=NX,0,-1
      N = NN
      IF (C(N).NE.0.0D0) GO TO 19
   11 CONTINUE
      RETURN
   19 CONTINUE
      DO 21 NN=0,N-1
        C(NN) = C(NN) / C(N)
   21 CONTINUE
        C(N) = 1.0D0
      RETURN
      END

C      REAL FUNCTION POLY (NX,C,Z)
C      REAL C(0:NX)
C        POLY = C(0)
C      DO 11 N=1,NX
C        POLY = POLY + C(N) * Z**N
C   11 CONTINUE
C      RETURN
C      END

      REAL*8 FUNCTION POLY (NX,C,Z)
      REAL*8 C(0:NX),Z
        POLY = C(0)
      DO 11 N=1,NX
        POLY = POLY + C(N) * Z**N
   11 CONTINUE
      RETURN
      END
