C ========================================
C   INITIAL CONDITIONS
C ========================================

      SUBROUTINE SETGR (LX,MX,DX,DY)
      REAL DX(MX),DY(MX)
      CALL CONST (PI,RE,OM)
      Y1 = -0.90E2
      Y2 = +0.90E2
      DO 11 M=1,MX
        Y =   Y1 * (REAL(MX-M)+0.5E0) / REAL(MX)
     +      + Y2 * (REAL(M)-0.5E0) / REAL(MX)
        DX(M) = 0.2E1 * PI * RE / REAL(LX)
     +          * COS(0.2E1*PI*Y/0.360E3)
        DY(M) = 0.2E1 * PI * RE * (Y2-Y1) / 0.360E3 / REAL(MX)
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SETCR (LX,MX,F)
      REAL F(LX,MX)
      CALL CONST (PI,RE,OM)
      Y1 = -0.90E2
      Y2 = +0.90E2
      DO 11 M=1,MX
        Y =   Y1 * (REAL(MX-M)+0.5E0) / REAL(MX)
     +      + Y2 * (REAL(M)-0.5E0) / REAL(MX)
      DO 12 L=1,LX
        F(L,M) = 0.2E1 * OM * SIN(0.2E1*PI*Y/0.360E3)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================

      SUBROUTINE CONST (PI,RE,OM)
      PI = 0.31415926535E1
      RE = 0.6368E7
      OM = 0.7292E-4
      RETURN
      END

C ========================================
C   DIAGNOSES OF DEPENDENT VARIABLES
C ========================================

      SUBROUTINE DIAUV (LX,MX,DX,DY,PS,U,V)
      REAL DX(MX),DY(MX),F(LX,MX),
     +     PS(LX,MX+1),U(LX,MX),V(LX,MX+1)
      DO 11 M=1,MX
      CALL EGNM (MX,M,M1,M2)
      DO 12 L=1,LX
        U(L,M) = - (PS(L,M2)-PS(L,M))/DY(M)
   12 CONTINUE
   11 CONTINUE
      DO 21 M=2,MX
      DO 22 L=1,LX
      CALL EGNL (LX,L,L1,L2)
        V(L,M) = + (PS(L2,M)-PS(L,M))/DX(M)
   22 CONTINUE
   21 CONTINUE
      RETURN
      END

      SUBROUTINE DIAXI (LX,MX,DX,DY,U,V,XI)
      REAL DX(MX),DY(MX),U(LX,MX),V(LX,MX+1),XI(LX,MX)
      DO 11 M=1,MX
      CALL EGNM (MX,M,M1,M2)
      DO 12 L=1,LX
      CALL EGNL (LX,L,L1,L2)
        UY = 0.25E0
     +       * ( (DX(M2  )*U(L ,M2  )-DX(M2-1)*U(L ,M2-1))
     +           /(0.5E0*(DY(M2-1)+DY(M2  ))*0.5E0*(DX(M2-1)+DX(M2  )))
     +          +(DX(M1+1)*U(L ,M1+1)-DX(M1  )*U(L ,M1  ))
     +           /(0.5E0*(DY(M1  )+DY(M1+1))*0.5E0*(DX(M1  )+DX(M1+1)))
     +          +(DX(M2  )*U(L2,M2  )-DX(M2-1)*U(L2,M2-1))
     +           /(0.5E0*(DY(M2-1)+DY(M2  ))*0.5E0*(DX(M2-1)+DX(M2  )))
     +          +(DX(M1+1)*U(L2,M1+1)-DX(M1  )*U(L2,M1  ))
     +           /(0.5E0*(DY(M1  )+DY(M1+1))*0.5E0*(DX(M1  )+DX(M1+1))))
        VX = 0.5E0
     +       * ( (V(L2,M  )-V(L1,M  ))/(DX(M1)+DX(M ))
     +          +(V(L2,M+1)-V(L1,M+1))/(DX(M )+DX(M2)))
        XI(L,M) = VX - UY
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE DIAPS (LX,MX,NNX,BCOS,BSIN,W,G,GG,GCOS,GSIN,DM)
      REAL BCOS(LX,MX+1,0:NNX,0:NNX),BSIN(LX,MX+1,0:NNX,0:NNX),
     +     W(LX,MX+1),
     +     G(LX,MX),GG(LX,MX+1),
     +     GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX),DM(LX,MX+1)
      CALL GCNV1 (LX,MX,G,DM)
      CALL POISS (LX,MX+1,NNX,BCOS,BSIN,W,DM,GG,GCOS,GSIN)
      CALL RESET (LX,MX+1,DM)
      RETURN
      END

C ========================================
C   BASIC ROUTINES
C ========================================

      SUBROUTINE EGNL (LX,L,L1,L2)
        L1 = L-1
        IF (L1.LT. 1) L1 = LX
        L2 = L+1
        IF (L2.GT.LX) L2 = 1
      RETURN
      END

      SUBROUTINE EGNM (MX,M,M1,M2)
        M1 = MAX0(M-1, 1)
        M2 = MIN0(M+1,MX)
      RETURN
      END

      SUBROUTINE RESET (LX,MX,G)
      REAL G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        G(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SUMM (LX,MX,G1,G2,G)
      REAL G1(LX,MX),G2(LX,MX),G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        G(L,M) = G1(L,M) + G2(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE DIFF (LX,MX,G1,G2,G)
      REAL G1(LX,MX),G2(LX,MX),G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        G(L,M) = G1(L,M) - G2(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ======================================== 

      SUBROUTINE GCNV1 (LX,MX,G,GG)
      REAL G(LX,MX),GG(LX,MX+1)
      DO 11 M=2,MX
      CALL EGNM (MX,M,M1,M2)
      DO 12 L=1,LX
      CALL EGNL (LX,L,L1,L2)
        GG(L,M) = 0.25E0*(G(L1,M1)+G(L,M1)+G(L1,M)+G(L,M))
   12 CONTINUE
   11 CONTINUE
      DO 21 L=1,LX
        GG(L,   1) = 0.0E0
        GG(L,MX+1) = 0.0E0
   21 CONTINUE
      RETURN
      END

      SUBROUTINE GCNV2 (LX,MX,G,GG)
      REAL G(LX,MX+1),GG(LX,MX)
      DO 11 M=1,MX
      M1 = M
      M2 = M+1
      DO 12 L=1,LX
      L1 = L
      L2 = L+1
      IF (L2.GT.LX) L2 = L2-LX
        GG(L,M) = 0.25E0*(G(L1,M1)+G(L2,M1)+G(L1,M2)+G(L2,M2))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================
C   DYNAMICAL PROCESSES
C ========================================

      SUBROUTINE ADVEC (LX,MX,DX,DY,U,V,G,DG)
      REAL DX(MX),DY(MX),U(LX,MX),V(LX,MX+1),G(LX,MX),DG(LX,MX)
      DO 11 M=1,MX
      CALL EGNM (MX,M,M1,M2)
      DX1 = 0.5E0*(DX(M)+DX(M1))
      DX2 = 0.5E0*(DX(M)+DX(M2))
      DXDY = DX(M) * DY(M)
      DO 12 L=1,LX
      CALL EGNL (LX,L,L1,L2)
      DYU1 = DY(M) * U(L ,M)
      DYU2 = DY(M) * U(L2,M)
      DXV1 = DX1 * V(L,M  )
      DXV2 = DX2 * V(L,M+1)
        DG(L,M) = DG(L,M)
     +    - 0.5E0
     +    * (   DYU2 * (G(L2,M)-G(L,M))
     +        - DYU1 * (G(L1,M)-G(L,M))
     +        + DXV2 * (G(L,M2)-G(L,M))
     +        - DXV1 * (G(L,M1)-G(L,M)))
     +      / DXDY
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================
C   PHYSICAL PROCESSES
C ========================================

      SUBROUTINE DIFFU (LX,MX,DF,DX,DY,G0,G,DG)
      REAL DX(MX),DY(MX),G0(LX,MX),G(LX,MX),DG(LX,MX)
      DO 11 M=1,MX
      CALL EGNM (MX,M,M1,M2)
      DO 12 L=1,LX
      CALL EGNL (LX,L,L1,L2)
        DG(L,M) = DG(L,M)
     +    + DF * 0.5E0 * (
     +        (G(L1,M)-G0(L1,M)+G(L2,M)-G0(L2,M)
     +           -0.2E1*(G(L,M)-G0(L,M))) / DX(M)**2
     +      + (G(L,M1)-G0(L,M1)+G(L,M2)-G0(L,M2)
     +           -0.2E1*(G(L,M)-G0(L,M))) / DY(M)**2)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE SDIFF (LX,MX,NNX,BCOS,BSIN,W,C,G,DG,GCOS,GSIN,D1,D2)
      REAL BCOS(LX,MX+1,0:NNX,0:NNX),BSIN(LX,MX+1,0:NNX,0:NNX),
     +     W(LX,MX+1),
     +     G(LX,MX),DG(LX,MX),
     +     GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX),
     +     D1(LX,MX),D2(LX,MX+1)
      CALL GCNV1 (LX,MX,G,D2)
      CALL POSDF (LX,MX+1,NNX,BCOS,BSIN,W,C,D2,D2,GCOS,GSIN)
      CALL GCNV2 (LX,MX,D2,D1)
      CALL SUMM  (LX,MX,DG,D1,DG)
      CALL RESET (LX,MX  ,D1)
      CALL RESET (LX,MX+1,D2)
      RETURN
      END

      SUBROUTINE DMPNG (LX,MX,TAU,G,DG)
      REAL G(LX,MX),DG(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
        DG(L,M) = DG(L,M)
     +    - 1.0E0 / TAU * G(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================
C   BOUNDARY CONDITIONS
C ========================================

      SUBROUTINE POLES (LX,MX,G)
      REAL G(LX,MX),GG(144)
      CALL CONST (PI,RE,OM)
      DO 11 M=1,MX
      K1 = INT(REAL(LX/2)*SIN(PI*REAL(M-1)/REAL(MX-1)))
        SUM = 0.0E0
      DO 21 L=1,LX
        SUM = SUM + G(L,M)
   21 CONTINUE
      DO 22 L=1,LX
        GG(L) = SUM/REAL(LX)
   22 CONTINUE
      DO 30 K=1,K1
        SUMS1 = 0.0E0
        SUMS0 = 0.0E0
        SUMC1 = 0.0E0
        SUMC0 = 0.0E0
      DO 31 L=1,LX
        TH = 0.2E1*PI*REAL(K)*REAL(L-1)/REAL(LX)
        SUMS1 = SUMS1 + G(L,M) * SIN(TH)
        SUMS0 = SUMS0 + SIN(TH)**2
        SUMC1 = SUMC1 + G(L,M) * COS(TH)
        SUMC0 = SUMC0 + COS(TH)**2
   31 CONTINUE
        GS = SUMS1/SUMS0
        GC = SUMC1/SUMC0
      DO 32 L=1,LX
        TH = 0.2E1*PI*REAL(K)*REAL(L-1)/REAL(LX)
        GG(L) = GG(L) + GS * SIN(TH)
        GG(L) = GG(L) + GC * COS(TH)
   32 CONTINUE
   30 CONTINUE
      DO 41 L=1,LX
        G(L,M) = GG(L)
   41 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================
C   TEMPORAL EVOLUTION
C ========================================

      SUBROUTINE INTEL (LX,MX,DTM,DG,GP,G)
      REAL DG(LX,MX),GP(LX,MX),G(LX,MX)
      EF = 0.5E-1
      DO 11 M=1,MX
      DO 12 L=1,LX
        GP1     = GP(L,M)
        GP(L,M) = ((1-0.2E1*EF)*G(L,M) + EF*GP(L,M)) / (1.0E0-EF)
        G (L,M) = GP1 + 0.2E1*DTM * DG(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE INTEE (LX,MX,DTM,DG,GP,G)
      REAL DG(LX,MX),GP(LX,MX),G(LX,MX)
      EF = 0.5E-1
      DO 11 M=1,MX
      DO 12 L=1,LX
        G (L,M) = G(L,M) + 0.2E1*DTM * DG(L,M)
        GP(L,M) = (1.0E0-EF)*GP(L,M) + EF*G(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================
C   POISSON EQUATION
C ========================================

      SUBROUTINE POPRE (LX,MX,NNX,POFL1,POFL2,POFL3,BCOS,BSIN,W)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX)
      CHARACTER POFL1*80,POFL2*80,POFL3*80
      CALL POBSS (LX,MX,NNX,POFL1,POFL2,BCOS,BSIN)
      CALL POWGT (LX,MX,POFL3,W)
      RETURN
      END

      SUBROUTINE POISS (LX,MX,NNX,BCOS,BSIN,W,G,GG,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GG(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL CONST (PI,RE,OM)
      CALL POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      CALL POCAL (NNX,RE,GCOS,GSIN)
      CALL POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,GG)
      RETURN
      END

      SUBROUTINE POSDF (LX,MX,NNX,BCOS,BSIN,W,C,G,GG,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GG(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL CONST (PI,RE,OM)
      CALL POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      CALL POSDC (NNX,RE,C,GCOS,GSIN)
      CALL POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,GG)
      RETURN
      END

      SUBROUTINE POSDC (NNX,R,C,GCOS,GSIN)
      REAL GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
        GCOS(0,0) = 0.0E0
        GSIN(0,0) = 0.0E0
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        GCOS(MM,NN) = - C * GCOS(MM,NN)
     +                  * (REAL(NN*(NN+1))**2-REAL(4)) / R**4
        GSIN(MM,NN) = - C * GSIN(MM,NN)
     +                  * (REAL(NN*(NN+1))**2-REAL(4)) / R**4
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================

      SUBROUTINE POBSS (LX,MX,NNX,INFL1,INFL2,BCOS,BSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX)
      CHARACTER INFL1*80,INFL2*80
      OPEN (10,FILE=INFL1,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX*(NNX+1)*(NNX+1)),ERR=99)
      READ(10,REC=1,ERR=99) BCOS
      CLOSE(10)
      OPEN (10,FILE=INFL2,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX*(NNX+1)*(NNX+1)),ERR=99)
      READ(10,REC=1,ERR=99) BSIN
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      WRITE(6,*) 'Can not read file.'
      STOP
      END

      SUBROUTINE POWGT (LX,MX,INFL,W)
      REAL W(LX,MX)
      CHARACTER INFL*80
      OPEN (10,FILE=INFL,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX),ERR=99)
      READ(10,REC=1,ERR=99) W
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      WRITE(6,*) 'Can not read file.'
      STOP
      END
    
      SUBROUTINE POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL POZER (0,NNX,0,NNX,GCOS)
      CALL POZER (0,NNX,0,NNX,GSIN)
      DO 11 NN=1,NNX
        CALL POPRJ1 (LX,MX,NNX,NN, 0,BCOS,W,G,GCOS( 0,NN))
      DO 12 MM=1,NN
        CALL POPRJ1 (LX,MX,NNX,NN,MM,BCOS,W,G,GCOS(MM,NN))
        CALL POPRJ1 (LX,MX,NNX,NN,MM,BSIN,W,G,GSIN(MM,NN))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POPRJ1 (LX,MX,NNX,NN,MM,B,W,G,G1)
      REAL B(LX,MX,0:NNX,0:NNX),W(LX,MX),G(LX,MX)
        SUM1 = 0.0E0
        SUM0 = 0.0E0 
      DO 11 M=1,MX
      DO 12 L=1,LX
      CALL POSPH (LX,MX,L,M,X,Y)
        SUM1 = SUM1 + W(L,M) * B(L,M,MM,NN) * G(L,M)
        SUM0 = SUM0 + W(L,M) * B(L,M,MM,NN)**2
   12 CONTINUE
   11 CONTINUE
        G1 = SUM1 / SUM0
      RETURN
      END

      SUBROUTINE POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,G)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),
     +     G(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL POZER (1,LX,1,MX,G)
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        CALL POCOM1 (LX,MX,NNX,NN,MM,BCOS,GCOS(MM,NN),G)
        CALL POCOM1 (LX,MX,NNX,NN,MM,BSIN,GSIN(MM,NN),G)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POCOM1 (LX,MX,NNX,NN,MM,B,G1,G)
      REAL B(LX,MX,0:NNX,0:NNX),G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
      CALL POSPH (LX,MX,L,M,X,Y)
        G(L,M) = G(L,M) + G1 * B(L,M,MM,NN)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POCAL (NNX,R,GCOS,GSIN)
      REAL GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
        GCOS(0,0) = 0.0E0
        GSIN(0,0) = 0.0E0
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        GCOS(MM,NN) = - GCOS(MM,NN) * R**2 / REAL(NN*(NN+1))
        GSIN(MM,NN) = - GSIN(MM,NN) * R**2 / REAL(NN*(NN+1))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POSPH (LX,MX,L,M,X,Y)
      CALL CONST (PI,RE,OM)
        X = 0.2E1*PI*REAL(L-1)/REAL(LX)
        Y = 0.5E0*PI-PI*REAL(M-1)/REAL(MX-1)
      RETURN
      END

      SUBROUTINE POZER (L1,L2,M1,M2,G)
      REAL G(L1:L2,M1:M2)
      DO 11 M=M1,M2
      DO 12 L=L1,L2
        G(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
      RETURN
      END
