      PARAMETER (LX=144,MX=73,NNX=42)
      REAL XI(LX,MX),PS(LX,MX)
      REAL BC(LX,MX,0:NNX,0:NNX),BS(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     GC(0:NNX,0:NNX),GS(0:NNX,0:NNX)
      CHARACTER INFL*80,OUTFL*80,POFL1*80,POFL2*80,POFL3*80

C   Please specify the spherical harmonic function files and the weight
C   function file.
      WRITE(6,*)
     +  'Data file of spherical harmonic functions & weight function:'
      POFL1 = 'bases73_cos.dat'
      POFL2 = 'bases73_sin.dat'
      POFL3 = 'weight73.dat'
      WRITE(6,'(1X,A32,A24)') 'Harmonic functions (cos-type) = ',POFL1
      WRITE(6,'(1X,A32,A24)') 'Harmonic functions (sin-type) = ',POFL2
      WRITE(6,'(1X,A32,A24)') 'Weight function               = ',POFL3
      CALL POPRE (LX,MX,NNX,POFL1,POFL2,POFL3,BC,BS,W)
      WRITE(6,*) '===================================='

      CALL FNAME (INFL,OUTFL)
      N = 1
   11 CONTINUE
      CALL RDDAT (LX,MX,INFL,N,NEND,XI)
      IF (NEND.EQ.1) GO TO 19
      CALL POISS (LX,MX,NNX,BC,BS,W,XI,PS,GC,GS)
      CALL DEVZ  (LX,MX,PS)
      CALL GSTRM (LX,MX,PS)
      CALL WRDAT (LX,MX,OUTFL,N,PS)
      N = N + 1
      GO TO 11
   19 CONTINUE
      WRITE(6,'(1X,A19,1X,I3)') 'Number of records =',N-1
      STOP
      END

C ========================================

      SUBROUTINE FNAME (INFL,OUTFL)
      CHARACTER INFL*80,OUTFL*80
C      WRITE(6,*) 'Input data ?'
C      READ (5,'(A80)') INFL
      INFL = 'X3001.dat'
C      WRITE(6,*) 'Output data ?'
C      READ (5,'(A80)') OUTFL
      OUTFL = 'Z3001.dat'
      WRITE(6,'(1X,A14,A24)') 'Input file  = ',INFL
      WRITE(6,'(1X,A14,A24)') 'Output file = ',OUTFL
      WRITE(6,*) '===================================='
      RETURN
      END

      SUBROUTINE RDDAT (LX,MX,INFL,N,NEND,G)
      REAL G(LX,MX)
      CHARACTER INFL*80
      NEND = 0
      OPEN(10,FILE=INFL,
     +     STATUS='OLD',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(LX*MX))
      READ(10,REC=N,ERR=99) G
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      NEND = 1
      RETURN
      END

      SUBROUTINE WRDAT (LX,MX,OUTFL,N,G)
      REAL G(LX,MX)
      CHARACTER OUTFL*80
      OPEN(10,FILE=OUTFL,
     +     STATUS='UNKNOWN',FORM='UNFORMATTED',
     +     ACCESS='DIRECT',RECL=4*(LX*MX))
      WRITE(10,REC=N) G
      CLOSE(10)
      RETURN
      END

C ========================================

      SUBROUTINE DEVZ (LX,MX,G)
      REAL G(LX,MX)
      DO 11 M=1,MX
        SUM = 0.0E0
      DO 21 L=1,LX
        SUM = SUM + G(L,M)
   21 CONTINUE
        AVE = SUM / REAL(LX)
      DO 22 L=1,LX
        G(L,M) = G(L,M) - AVE
   22 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE GSTRM (LMAX,MMAX,Z)
      REAL Z(LMAX,MMAX)
      PI = 0.31415926535E1
      OM = 0.7292E-4
      GC = 0.9807E1
      DO 11 M=1,MMAX
        TH = PI*(0.5E0-REAL(M-1)/REAL(MMAX-1))
        F  = 0.2E1 * OM * SIN(TH)
      DO 12 L=1,LMAX
        Z(L,M) = F / GC * Z(L,M)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================

      SUBROUTINE CONST (PI,RE,OM)
      PI = 0.31415926535E1
      RE = 0.6368E7
      OM = 0.7292E-4
      RETURN
      END

C ========================================

      SUBROUTINE POPRE (LX,MX,NNX,POFL1,POFL2,POFL3,BCOS,BSIN,W)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX)
      CHARACTER POFL1*80,POFL2*80,POFL3*80
      CALL POBSS (LX,MX,NNX,POFL1,POFL2,BCOS,BSIN)
      CALL POWGT (LX,MX,POFL3,W)
      RETURN
      END

      SUBROUTINE POISS (LX,MX,NNX,BCOS,BSIN,W,G,GG,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GG(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL CONST (PI,RE,OM)
      CALL POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      CALL POCAL (NNX,RE,GCOS,GSIN)
      CALL POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,GG)
      RETURN
      END

      SUBROUTINE POSDF (LX,MX,NNX,BCOS,BSIN,W,C,G,GG,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GG(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL CONST (PI,RE,OM)
      CALL POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      CALL POSDC (NNX,RE,C,GCOS,GSIN)
      CALL POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,GG)
      RETURN
      END

      SUBROUTINE POSDC (NNX,R,C,GCOS,GSIN)
      REAL GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
        GCOS(0,0) = 0.0E0
        GSIN(0,0) = 0.0E0
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        GCOS(MM,NN) = - C * GCOS(MM,NN)
     +                  * (REAL(NN*(NN+1))**2-REAL(4)) / R**4
        GSIN(MM,NN) = - C * GSIN(MM,NN)
     +                  * (REAL(NN*(NN+1))**2-REAL(4)) / R**4
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

C ========================================

      SUBROUTINE POBSS (LX,MX,NNX,INFL1,INFL2,BCOS,BSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX)
      CHARACTER INFL1*80,INFL2*80
      OPEN (10,FILE=INFL1,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX*(NNX+1)*(NNX+1)),ERR=99)
      READ(10,REC=1,ERR=99) BCOS
      CLOSE(10)
      OPEN (10,FILE=INFL2,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX*(NNX+1)*(NNX+1)),ERR=99)
      READ(10,REC=1,ERR=99) BSIN
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      WRITE(6,*) 'Can not read file.'
      STOP
      END

      SUBROUTINE POWGT (LX,MX,INFL,W)
      REAL W(LX,MX)
      CHARACTER INFL*80
      OPEN (10,FILE=INFL,
     +      STATUS='OLD',FORM='UNFORMATTED',
     +      ACCESS='DIRECT',RECL=4*(LX*MX),ERR=99)
      READ(10,REC=1,ERR=99) W
      CLOSE(10)
      RETURN
   99 CLOSE(10)
      WRITE(6,*) 'Can not read file.'
      STOP
      END
    
      SUBROUTINE POPRJ (LX,MX,NNX,BCOS,BSIN,W,G,GCOS,GSIN)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),W(LX,MX),
     +     G(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL POZER (0,NNX,0,NNX,GCOS)
      CALL POZER (0,NNX,0,NNX,GSIN)
      DO 11 NN=1,NNX
        CALL POPRJ1 (LX,MX,NNX,NN, 0,BCOS,W,G,GCOS( 0,NN))
      DO 12 MM=1,NN
        CALL POPRJ1 (LX,MX,NNX,NN,MM,BCOS,W,G,GCOS(MM,NN))
        CALL POPRJ1 (LX,MX,NNX,NN,MM,BSIN,W,G,GSIN(MM,NN))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POPRJ1 (LX,MX,NNX,NN,MM,B,W,G,G1)
      REAL B(LX,MX,0:NNX,0:NNX),W(LX,MX),G(LX,MX)
        SUM1 = 0.0E0
        SUM0 = 0.0E0 
      DO 11 M=1,MX
      DO 12 L=1,LX
      CALL POSPH (LX,MX,L,M,X,Y)
        SUM1 = SUM1 + W(L,M) * B(L,M,MM,NN) * G(L,M)
        SUM0 = SUM0 + W(L,M) * B(L,M,MM,NN)**2
   12 CONTINUE
   11 CONTINUE
        G1 = SUM1 / SUM0
      RETURN
      END

      SUBROUTINE POCOM (LX,MX,NNX,BCOS,BSIN,GCOS,GSIN,G)
      REAL BCOS(LX,MX,0:NNX,0:NNX),BSIN(LX,MX,0:NNX,0:NNX),
     +     G(LX,MX),GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
      CALL POZER (1,LX,1,MX,G)
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        CALL POCOM1 (LX,MX,NNX,NN,MM,BCOS,GCOS(MM,NN),G)
        CALL POCOM1 (LX,MX,NNX,NN,MM,BSIN,GSIN(MM,NN),G)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POCOM1 (LX,MX,NNX,NN,MM,B,G1,G)
      REAL B(LX,MX,0:NNX,0:NNX),G(LX,MX)
      DO 11 M=1,MX
      DO 12 L=1,LX
      CALL POSPH (LX,MX,L,M,X,Y)
        G(L,M) = G(L,M) + G1 * B(L,M,MM,NN)
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POCAL (NNX,R,GCOS,GSIN)
      REAL GCOS(0:NNX,0:NNX),GSIN(0:NNX,0:NNX)
        GCOS(0,0) = 0.0E0
        GSIN(0,0) = 0.0E0
      DO 11 NN=1,NNX
      DO 12 MM=0,NN
        GCOS(MM,NN) = - GCOS(MM,NN) * R**2 / REAL(NN*(NN+1))
        GSIN(MM,NN) = - GSIN(MM,NN) * R**2 / REAL(NN*(NN+1))
   12 CONTINUE
   11 CONTINUE
      RETURN
      END

      SUBROUTINE POSPH (LX,MX,L,M,X,Y)
      CALL CONST (PI,RE,OM)
        X = 0.2E1*PI*REAL(L-1)/REAL(LX)
        Y = 0.5E0*PI-PI*REAL(M-1)/REAL(MX-1)
      RETURN
      END

      SUBROUTINE POZER (L1,L2,M1,M2,G)
      REAL G(L1:L2,M1:M2)
      DO 11 M=M1,M2
      DO 12 L=L1,L2
        G(L,M) = 0.0E0
   12 CONTINUE
   11 CONTINUE
      RETURN
      END
